<?php
header('Content-Type: application/json');

$lobbies = json_decode(file_get_contents("../__lobby_table.json"), true);
//We need league names
$leagues = json_decode(file_get_contents("../__league_table.json"), true);
//We need team name and logo
$teams = json_decode(file_get_contents("../__team_table.json"), true);

$DOTA_TEAM_SPECTATORS = 1;
$DOTA_TEAM_GOODGUYS = 2;
$DOTA_TEAM_BADGUYS = 3;
$DOTA_TEAM_NEUTRALS = 4;
$DOTA_TEAM_NOTEAM = 5;
$DOTA_TEAM_CUSTOM_1 = 6;
$DOTA_TEAM_CUSTOM_2 = 7;
$DOTA_TEAM_CUSTOM_3 = 8;
$DOTA_TEAM_CUSTOM_4 = 9;
$DOTA_TEAM_CUSTOM_5 = 10;
$DOTA_TEAM_CUSTOM_6 = 11;
$DOTA_TEAM_CUSTOM_7 = 12;
$DOTA_TEAM_CUSTOM_8 = 13;

if(isset($_GET["lobby"])) {
    if (array_key_exists($_GET["lobby"], $lobbies)) {
        $lobby = $lobbies[$_GET["lobby"]];
        if ($lobby["active"]) {
            $lobby_info = [];
            if (array_key_exists("team2", $lobby)) {
                if (!array_key_exists("team", $lobby_info)) {
                    $lobby_info["team"] = [];
                }
                //lookup team name/logo
                if (array_key_exists($lobby["team2"], $teams)) {
                    $lobby_info["team"][2] = [
                        "name" => $teams[$lobby["team2"]]["name"],
                        "logo" => $teams[$lobby["team2"]]["logo"]
                    ];
                } else {
                    echo('{"error":"Invalid team2!"}');
                    return;
                }
            }
            if (array_key_exists("team2_players", $lobby)) {
                if (!array_key_exists("teams", $lobby_info)) {
                    $lobby_info["teams"] = [];
                }
                //Array of Strings because Lua is shit
                $lobby_info["teams"][2] = $lobby["team2_players"];
            }
            if (array_key_exists("team3", $lobby)) {
                if (!array_key_exists("team", $lobby_info)) {
                    $lobby_info["team"] = [];
                }
                //lookup team name/logo
                if (array_key_exists($lobby["team3"], $teams)) {
                    $lobby_info["team"][3] = [
                        "name" => $teams[$lobby["team3"]]["name"],
                        "logo" => $teams[$lobby["team3"]]["logo"]
                    ];
                } else {
                    echo('{"error":"Invalid team3!"}');
                    return;
                }
            }
            if (array_key_exists("team3_players", $lobby)) {
                if (!array_key_exists("teams", $lobby_info)) {
                    $lobby_info["teams"] = [];
                }
                //Array of Strings because Lua is shit
                $lobby_info["teams"][3] = $lobby["team3_players"];
            }
            //TODO: CUSTOM 1 to 8
            if (array_key_exists("league", $lobby)) {
                //Need to lookup league name
                if (array_key_exists((string)$lobby["league"], $leagues)) {
                    $lobby_info["league"] = $leagues[(string)$lobby["league"]]["name"];
                } else {
                    echo('{"error":"Invalid League!"}');
                    return;
                }
            }
            if (array_key_exists("name", $lobby)) {
               $lobby_info["name"] = $lobby["name"];
            }
            if (array_key_exists("spectators", $lobby)) {
                //insert test spectators here, BROADCAST_SLOT => [STEAMID ARRAY]
                $lobby_info["spectators"] = $lobby["spectators"];
            }
            if (array_key_exists("unassigned", $lobby)) {
                //array of steamID's
                $lobby_info["unassigned"] = $lobby["unassigned"];
            }
            if (array_key_exists("broadcast", $lobby)) {
                //insert broadcast channel info here if broadcasters are present,
                //"name" => "Moonduck.TV", "country" => "us"
                //TODO: Validate or do more fancy logic here.
                $lobby_info["broadcast"] = $lobby["broadcast"];
            }
            echo(json_encode($lobby_info));
        } else {
            echo('{"error" : "Inactive lobby!"}');
        }
    } else {
    echo('{"error" : "Unknown lobby!"}');
    }
} else {
echo('{"error" : "Missing lobby field!"}');
}